#####################################################################################
#
# IRC  " "
#
##################################################################################### 
# : 2.5
# : Death_Lord
# E-Mail: death_lord@list.ru
# IRC: irc://irc.krasnogorsk.ru/ALL_RPG
#####################################################################################

### -= CONFIG =- ###

#     (Default: "scripts/ruletka/")
set ruletka(dir) "scripts/ruletka/"

#     ... (Default: "!")
set ruletka(pref) "!"

#         (Default: "50")
set ruletka(min_games) "50"

#   
# 0 -    
# 1 -    
#   RANDNICK,    
set ruletka(result) {
	{1 %c12   Desert Eagle 50 %c ... %c04%b%b%c ... %c04 . %c05       %c ... }
	{1 %c12    Desert Eagle    ...       %c ... %c04%c ... %c04    ,   ,          .}
	{1 %c12    ...   %c ... %c04%c ... %c04     %c ...}
	{0 %c12    ...   %c ... %c03%c ... %c03  ,      -.}
	{0 %c12  ...  %c ... %c03   RANDNICK,   %c ... %c04     RANDNICK}
	{0 %c12 -47    %c ... %c03       %c ... %c04       -  %c ... %c04 -  RANDNICK%c ...}
	{0 %c12     ,   %c ... %c03 ... '' ...   ... '' ...    ... ',    ' -  %c ...}
	{0 %c12 %c ... %c3   ,          ''%c ...}
	{0 %c12 %c ... %c12     %c ... %c03%c ... %c03'' %c...%c03        ''%c ... }
}

#    =)
set ruletka(races) {
	{ } { } {  } {}
	{} { } {} {  }
	{} { } {} { }
	{ } {} {  } {  }
	{} { ,   } {} { }
	{ } { } { } {}
	{}
}

### -= END OF CONFIG =- ###


### -= BINDS =- ###
bind pub -|- ${ruletka(pref)}reg ::ruletka::reg
bind pub -|- ${ruletka(pref)} ::ruletka::reg
bind pub -|- ${ruletka(pref)} ::ruletka::reg
bind pub -|- ${ruletka(pref)}htu ::ruletka::reg
bind pub -|- ${ruletka(pref)}ruletka ::ruletka::game
bind pub -|- ${ruletka(pref)} ::ruletka::game
bind pub -|- ${ruletka(pref)} ::ruletka::game
bind pub -|- ${ruletka(pref)} ::ruletka::game
bind pub -|- ${ruletka(pref)} ::ruletka::game
bind pub -|- ${ruletka(pref)}stats ::ruletka::stat
bind pub -|- ${ruletka(pref)}rstat ::ruletka::stat
bind pub -|- ${ruletka(pref)}rstats ::ruletka::stat
bind pub -|- ${ruletka(pref)} ::ruletka::stat
bind pub -|- ${ruletka(pref)} ::ruletka::stat
bind pub -|- ${ruletka(pref)} ::ruletka::stat
bind pub -|- ${ruletka(pref)} ::ruletka::top
bind pub -|- ${ruletka(pref)}rtop ::ruletka::top
bind pub -|- ${ruletka(pref)}rhelp ::ruletka::help
bind pub -|- ${ruletka(pref)} ::ruletka::help
bind pub -|- ${ruletka(pref)} ::ruletka::help


### -= SCRIPT =- ###
namespace eval ruletka {}
set ruletka(version) "2.6"
set ruletka(helpfile) "${ruletka(dir)}help.txt"
setudef flag noruletka
proc ::ruletka::reg {nick uhost hand chan text} {
	global ruletka
	set uhost "\*\!\*\@[lindex [split $uhost "@"] 1]"
	if {[channel get $chan noruletka]} { ::egglib::outn $nick "\00304 \00303' '\00304    ."; return }
	set race [lindex $ruletka(races) [rand [llength $ruletka(races)]]]
	set file "$ruletka(dir)ruletka.user"
	set data [::egglib::readdata $file]
	if {[::ruletka::checkuser $file $data $nick $uhost] != ""} { ::egglib::outn $nick "\00303     ."; return }
	set user "--HAND $nick \| --HOSTS $uhost \| --RACE $race \| --DEATH 0 \| --SURV 0 \| --ALL 0 \|"
	set data [linsert $data end $user]
	::egglib::writedata $file $data
	::egglib::outn $nick "\00303       ,\00307 $nick\00303!   \00306$race\00303!      :\00304 ${ruletka(pref)} ${ruletka(pref)} ${ruletka(pref)} ${ruletka(pref)} ${ruletka(pref)}ruletka."
}
proc ::ruletka::checkuser {file data nick uhost} {
	global ruletka
	set s ""
	foreach line $data {
		if {[regexp -nocase -- {--HAND\ (.*?)\ \|\ --HOSTS\ (.*?)\ \|\ --RACE\ (.*?)\ \|\ --DEATH\ (.*?)\ \|\ --SURV\ (.*?)\ \|\ --ALL\ (.*?)\ \|} $line garb uhand hosts race death surv all]} {
			if {($nick == $uhand) || ([lsearch $hosts $uhost] != "-1")} { set s "$uhand \{$hosts\} \{$race\} $death $surv $all" }
		}
	}
	return $s
}
proc ::ruletka::game {nick uhost hand chan text} {
	global ruletka botnick
	if {[llength [chanlist $chan]] < 3} { ::egglib::out $nick $chan "\00304,      2 ."; return }
	set sc [lindex $text 0]
	if {$sc != ""} { ::egglib::outn $nick "\00303  :\00304 ! ! ! ! !ruletka \00306!stats ! \00307! !reg ! !htu \00305! !rtop"; return }
	set uhost "\*\!\*\@[lindex [split $uhost "@"] 1]"
	if {[channel get $chan noruletka]} { ::egglib::outn $nick "\00304 \00303' '\00304    ."; return }
	set file "$ruletka(dir)ruletka.user"
	set data [::egglib::readdata $file]
	set user [::ruletka::checkuser $file $data $nick $uhost]
	if {$user == ""} { ::egglib::outn $nick "\00303       \;\) \00304 ${ruletka(pref)}"; return }
	if {![matchattr $hand m]} {
		set lines [utimers]
		set ttime ""
		foreach line $lines {
			if {"::ruletka::reset $uhost" == [lindex $line 1]} { set ttime [lindex $line 0] }
		}
		set ttime [duration $ttime]
		regsub -all -- "minutes" "$ttime" "" ttime
		regsub -all -- "minute" "$ttime" "" ttime
		regsub -all -- "seconds" "$ttime" "" ttime
		regsub -all -- "second" "$ttime" "" ttime
		if {[info exists ::ruletka::pub(host,$uhost)]} {
			::egglib::outn $nick "        3 .    $ttime."
			return
		}
		set ::ruletka::pub(host,$uhost) 1
		set ::ruletka::pub(timer,$uhost) [utimer 180 [list ::ruletka::reset $uhost]]
	}
	set uhand [lindex $user 0]
	set hosts [lindex $user 1]
	set race [lindex $user 2]
	set death [lindex $user 3]
	set surv [lindex $user 4]
	set all [expr [lindex $user 5] + 1]
	set result [lindex $ruletka(result) [rand [llength $ruletka(result)]]]
	set a [lindex $result 0]
	set result [lrange $result 1 end]
	set result [::egglib::meta_to_colors $result]
	if {[regexp -nocase -- "RANDNICK" $result]} { set rr 1 } else { set rr 0 }
	set randnick [lindex [chanlist $chan] [rand [llength [chanlist $chan]]]]
	while {($randnick == $botnick) || ($randnick == $nick)} { set randnick [lindex [chanlist $chan] [rand [llength [chanlist $chan]]]] }
	regsub -all -- "RANDNICK" $result "$randnick" result
	set rhost "\*\!\*\@[lindex [split [getchanhost $randnick $chan] "@"] 1]"
	set result2s {
		{%c04UHAND %c  %c05RACE}
		{%c05RACE %c04(UHAND)}
		{%c04UHAND %c-%c05 RACE}
	}
	set result2 [lindex $result2s [rand [llength $result2s]]]
	regsub -all -- "RACE" $result2 "$race" result2
	regsub -all -- "UHAND" $result2 "$uhand" result2
	set result2 [::egglib::meta_to_colors $result2]
	::egglib::out $chan $chan "$result2\003 $result"
	if {$a == 1} { set death [expr $death + 1] } else { set surv [expr $surv + 1] }
	set ndata {}; set rrr 0
	foreach line $data {
		if {$rr == 1} {
			if {[regexp -nocase -- {--HAND\ (.*?)\ \|\ --HOSTS\ (.*?)\ \|\ --RACE\ (.*?)\ \|\ --DEATH\ (.*?)\ \|\ --SURV\ (.*?)\ \|\ --ALL\ (.*?)\ \|} $line garb rhand rhosts rrace rdeath rsurv rall]} {
				if {[lsearch $rhosts $rhost] != "-1"} {
					set rrr 1
					set rdeath [expr $rdeath + 1]
					set line "--HAND $rhand \| --HOSTS $rhosts \| --RACE $rrace \| --DEATH $rdeath \| --SURV $rsurv \| --ALL $rall \|"
				}
			}
		}
		if {[lsearch $line $uhand] != "-1"} {
			set line "--HAND $uhand \| --HOSTS $hosts \| --RACE $race \| --DEATH $death \| --SURV $surv \| --ALL $all \|"
		}
		set ndata [linsert $ndata end $line]
	}
	if {($rr == 1) && ($rrr == 0)} {
		set rrace [lindex $ruletka(races) [rand [llength $ruletka(races)]]]
		set ndata [linsert $ndata end "--HAND $randnick \| --HOSTS $rhost \| --RACE $rrace \| --DEATH 1 \| --SURV 0 \| --ALL 0 \|"]
	}
	::egglib::writedata $file $ndata
}
proc ::ruletka::reset { uhost } {
	global ::ruletka::pub
	catch {killutimer $::ruletka::pub(timer,$uhost)}
	catch {unset ::ruletka::pub(timer,$uhost)}
	catch {unset ::ruletka::pub(host,$uhost)}
}
setudef flag quietrulstats
proc ::ruletka::stat {nick uhost hand chan text} {
	global ruletka
	set uhost "\*\!\*\@[lindex [split $uhost "@"] 1]"
	if {[channel get $chan noruletka]} { ::egglib::outn $nick "\00304 \00303' '\00304    ."; return }
	set file "$ruletka(dir)ruletka.user"
	set data [::egglib::readdata $file]
	set sc [lindex $text 0]
	if {$sc == ""} {
		set user [::ruletka::checkuser $file $data $nick $uhost]
		if {$user == ""} { ::egglib::outn $nick "\00303       \;\) \00304 ${ruletka(pref)}"; return }
	} else {
		set user [::ruletka::checkuser $file $data $sc "[getchanhost $sc $chan]"]
		if {$user == ""} { ::egglib::outn $nick "\00303   \00304$sc \00303   \;\)"; return }
	}
	set uhand [lindex $user 0]
	set hosts [lindex $user 1]
	set race [lindex $user 2]
	set death [lindex $user 3]
	set surv [lindex $user 4]
	set all [expr $death + $surv]
	set games [lindex $user 5]
	if {$all != 0} { set vit [expr round(( $surv * 100 ) / ${all}.0)] } else { set vit 0 }
	set output "\00305 \" \": \00306  \00304$uhand\00306,  \00304$race\00306,  \00304$death\00306,  \00304$surv\00306,   \00304$vit%\00306,   \00304$games\00306 ()."
	if {[channel get $chan quietrulstats]} {
		::egglib::outn $nick $output
	} else { ::egglib::outn $nick $output }
}
proc ::ruletka::top {nick uhost hand chan text} {
	global ruletka
	set uhost "\*\!\*\@[lindex [split $uhost "@"] 1]"
	if {[channel get $chan noruletka]} { ::egglib::outn $nick "\00304 \00303' '\00304    ."; return }
	set file "$ruletka(dir)ruletka.user"
	set data [::egglib::readdata $file]
	if {[::ruletka::checkuser $file $data $nick $uhost] == ""} { ::egglib::outn $nick "\00303       \;\) \00304 ${ruletka(pref)}"; return }
	set sc [lindex $text 0]
	set sur_top {}
	set death_top {}
	foreach line $data {
		if {[regexp -nocase -- {--HAND\ (.*?)\ \|\ --HOSTS\ (.*?)\ \|\ --RACE\ (.*?)\ \|\ --DEATH\ (.*?)\ \|\ --SURV\ (.*?)\ \|\ --ALL\ (.*?)\ \|} $line garb uhand hosts race death surv all]} {
			if {$all >= $ruletka(min_games)} {
				set vit [expr $surv * 100 / [expr $death + $surv]]
				set sur_top [linsert $sur_top end "$vit $uhand $race"]
				set death_top [linsert $death_top end "$death $uhand $race"]
			}
		}
	}
	set sur_top [lsort -dictionary -decreasing $sur_top]
	set death_top [lsort -dictionary -decreasing $death_top]
	if {$sc == "death"} {
		set y "1"
		foreach line $death_top {
			set d [lindex $line 0]
			set u [lindex $line 1]
			set r [lrange $line 2 end]
			if {$line != ""} {
				set out "\00304$y\003 | : \00307$u\003 | : \00306$r\003 | : \00312'$d'"
				::egglib::outn $nick $out
			}
			incr y
		}
	}
	if {($sc == "s") || ($sc == "")} {
		set x "1"
		foreach line $sur_top {
			set s [lindex $line 0]
			set u [lindex $line 1]
			set r [lrange $line 2 end]
			if {$s > 90} { set rank " " }
			if {($s <= 90) && ($s > 80)} { set rank "" }
			if {($s <= 80) && ($s > 70)} { set rank "" }
			if {($s <= 70) && ($s > 60)} { set rank "" }
			if {($s <= 60) && ($s > 50)} { set rank " " }
			if {($s <= 50) && ($s > 20)} { set rank "" }
			if {($s <= 20) && ($s > 10)} { set rank " " }
			if {($s <= 10) && ($s > 0)} { set rank "..." }
			if {$s == 0} { set rank ": ''" }
			if {$line != ""} { ::egglib::outn $nick "\00304$x\003 | : \00307$u\003 | : \00306$r\003 | : \00303$rank\003 | : \00312${s}%" }
			incr x
		}
	}
}
proc ::ruletka::help {nick uhost hand chan text} {
	global ruletka
	set data [::egglib::readdata $ruletka(helpfile)]
	foreach line $data { ::egglib::outm $nick [::egglib::meta_to_colors $line] }
}






set ruletka(weapons) {
	{-47 | %c04      (   ) %c07%bAK-47%b%c04    Had Shot %c06NICK%c04,        ... |}
	{Rocket Launcher | %c05  %c06NICK%c05   %c03Rocket Launcher%c05 '%u !%u' ...             %c06NICK%c05 ... |}
	{Railgun | %c04      ...    '! ;)'   %c07NICK%c04  %c12Railgun-%c04 ...  %c06NNICK%c04    ;)) |}
	{Shotgun | %c04  %c07Shotgun%c04     ...  () %c06NICK%c04 ...        () ()    ... |}
	{ | %c04      %c07 ''%c04       ... %c06NICK%c04    () ()   %c12NNICK%c04 ... |}
	{ | %c12... %c04     ()  %c06NICK%c04   ()  %c07%c04 ...   ()  ()     ... |}
	{BFG | %c04 %c07BFG%c04     %c12Quad Damage%c04 ...   %c06NICK%c04     %c12NNICK%c04         ... |}
}
bind pub -|- ! ::ruletka::rasstrelat
bind pub -|- ! ::ruletka::rasstrelat
bind pub -|- !kill ::ruletka::rasstrelat
bind pub -|- ! ::ruletka::rasstrelat
proc ::ruletka::rasstrelat {nick uhost hand chan text} {
	global ruletka
	set target [lindex $text 0]
	set weapon [lrange $text 1 end]
	if {$weapon == ""} { ::egglib::out $nick $chan "   () ."; return }
	set find 0
	foreach line $ruletka(weapons) {
		if {[regexp -nocase -- {(.*?)\ \|\ (.*?)\ \|} $line grab cweapon cresult]} {
			if {[regexp -nocase -- "$weapon" $cweapon]} { set find 1; set result $cresult }
		}
	}
	if {$find == 0} { ::egglib::out $nick $chan "   .";  return }
	if {[onchan $target $chan]} {
		regsub -all -- "NNICK" $result "$nick" result
		regsub -all -- "NICK" $result "$target" result
		set result [::egglib::meta_to_colors $result]
		::egglib::out $chan $chan "\00312\002$nick\002\003 $result"
	} else { ::egglib::out $nick $chan "     $chan" }
}
putlog "Script loaded: ruletka.tcl \[v $ruletka(version)\] by Death_Lord - death_lord@list.ru"